<script setup lang="ts">
import router from '@/router';
import { reactive, ref, onMounted, computed } from 'vue'
import { useRoute } from 'vue-router';
import type { Customer } from './CustomerPortal.vue';
import axios from 'axios';

defineProps<{
    id: string;
}>();

const route = useRoute();
const customerId = ref<number>();
const customerInfo = ref<Customer | null>(null);
const creatorName = ref<string>('');
const modifierName = ref<string>('');
const customerManagerName = ref<string>('');
const clone = ref();
const form = reactive({
    name: '',
    fax: '',
    telephone: '',
    website: '',
    postalCode: '',
    address: '',
    industry: '',
    headcount: '',
    type: '',
    annualRevenue: '',
    bankName: '',
    branchName: '',
    accountNumber: '',
    closingDate: '',
    paymentTerm: '',
    accountHolder: '',
    depositType: '',
    comment: ''
});

interface FormObject {
    [key: string]: any;
}

function cancel() {
    router.push("/customer/portal")
}

const onSubmit = async () => {
    const formChanged = computed(() => {
        return JSON.stringify(form) !== JSON.stringify(clone.value);
    });
    if (formChanged.value) {
        const diff = Object.entries(form)
            .filter(([key, value]) => clone.value[key] !== value)
            .reduce((acc: FormObject, [key, value]) => {
                acc[key] = value;
                return acc;
            }, {});
        console.log(diff)
        try {
            const response = await axios.put(
                `http://localhost:8080/api/v1/customers/${customerId.value}`,
                diff,
                {
                    headers: {
                        "Content-Type": "application/json",
                    },
                }
            );
            console.log("PUT request response:", response.data);
        } catch (error) {
            console.error("Error during the PUT request:", error);
        }
    }
};

onMounted(() => {
    customerId.value = parseInt(route.params.id as string);
    const savedData = localStorage.getItem(`customer-${customerId.value}`);
    if (savedData) {
        const data = JSON.parse(savedData);
        customerInfo.value = data.customerInfo;
        creatorName.value = data.creatorName;
        modifierName.value = data.modifierName;
        customerManagerName.value = data.customerManagerName;
        form.name = data.customerInfo.name;
        form.fax = data.customerInfo.fax;
        form.telephone = data.customerInfo.telephone;
        form.website = data.customerInfo.website;
        form.address = data.customerInfo.address;
        form.postalCode = data.customerInfo.postalCode;
        form.industry = data.customerInfo.industry;
        form.headcount = data.customerInfo.headcount;
        form.type = data.customerInfo.type;
        form.annualRevenue = data.customerInfo.annualRevenue;
        form.bankName = data.customerInfo.bankName;
        form.branchName = data.customerInfo.branchName;
        form.accountNumber = data.customerInfo.accountNumber;
        form.paymentTerm = data.customerInfo.paymentTerm;
        clone.value = JSON.parse(JSON.stringify(form));
    }
});

</script>

<template>
    <div>
        <!-- Top -->
        <div class="top-text-align-on-each-side">
            <span>取引先情報</span>

        </div>
        <div class="center-button-group">
            <el-button type="primary" plain size="small" @click="onSubmit">保存</el-button>
            <el-button type="primary" plain size="small" @click="cancel"
                class="button-group-auto-l-margin">キャンセル</el-button>
        </div>

        <!-- Form#取引先情報 -->
        <div class="customer-creation-component">
            <span class="component-title-text">取引先情報</span>
        </div>
        <div class="customer-component-wrapper">
            <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                <br />
                <el-form-item label="取引先所有者">
                    <span>{{ customerManagerName }}</span>
                </el-form-item>
                <br />
                <el-form-item label="取引先名">
                    <el-input v-model="form.name" />
                </el-form-item>
                <el-form-item label="FAX">
                    <el-input v-model="form.fax" />
                </el-form-item>
                <br />
                <el-form-item label="電話番号">
                    <el-input v-model="form.telephone" />
                </el-form-item>
                <el-form-item label="Webサイト">
                    <el-input v-model="form.website" />
                </el-form-item>
            </el-form>
        </div>

        <!-- Form#詳細情報 -->
        <div class="customer-creation-component">
            <span class="component-title-text">詳細情報</span>
        </div>
        <div class="customer-component-wrapper">
            <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                <br />
                <el-form-item label="住所">
                    <el-input v-model="form.address" />
                </el-form-item>
                <el-form-item label="郵便番号">
                    <el-input v-model="form.postalCode" />
                </el-form-item>
                <br />
                <el-form-item label="得意分野">
                    <el-select v-model="form.industry" class="el-select-width" placeholder="分野を選んでください">
                        <el-option value="金融系（銀行）" />
                        <el-option value="金融系（証券）" />
                        <el-option value="金融系（生損保）" />
                        <el-option value="金融系（その他）" />
                        <el-option value="流通" />
                        <el-option value="製造" />
                        <el-option value="組込み・制御" />
                        <el-option value="官公庁" />
                        <el-option value="その他" />
                    </el-select>
                </el-form-item>
                <el-form-item label="従業員数">
                    <el-input v-model="form.headcount" />
                </el-form-item>
                <br />
                <el-form-item label="取引先の種別">
                    <el-select v-model="form.type" class="el-select-width" placeholder="種別を選んでください">
                        <el-option value="アナリスト" />
                        <el-option value="競合" />
                        <el-option value="顧客" />
                        <el-option value="インテグレーター（統合）" />
                        <el-option value="投資家" />
                        <el-option value="パートナー" />
                        <el-option value="報道機関" />
                        <el-option value="見込顧客" />
                        <el-option value="代理店" />
                        <el-option value="その他" />
                    </el-select>
                </el-form-item>
                <el-form-item label="年間売上">
                    <el-input v-model="form.annualRevenue" />
                </el-form-item>
                <br />
                <el-form-item label="銀行名">
                    <el-input v-model="form.bankName" />
                </el-form-item>
                <el-form-item label="支店名">
                    <el-input v-model="form.branchName" />
                </el-form-item>
                <br />
                <el-form-item label="口座番号">
                    <el-input v-model="form.accountNumber" />
                </el-form-item>
                <el-form-item label="支払サイト">
                    <el-select v-model="form.paymentTerm" class="el-select-width-small" placeholder="支払サイト">
                        <el-option value="45" />
                        <el-option value="60" />
                        <el-option value="90" />
                    </el-select>
                </el-form-item>
                <br />
            </el-form>

            <div class="customer-creation-component">
                <span class="component-title-text">システム情報</span>
            </div>
            <div class="customer-component-wrapper">
                <el-form :model="form" label-width="auto" size="small" :inline="true" label-position="left">
                    <br>
                    <el-form-item label="作成者">
                        <el-input disabled v-model="creatorName" />
                        <span>{{ customerInfo?.createdTime }}</span>
                    </el-form-item>
                    <el-form-item label="最終更新者">
                        <el-input disabled v-model="modifierName" />
                        <span>{{ customerInfo?.modifiedTime }}</span>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>

<style>
.top-text-align-on-each-side {
    display: flex;
    justify-content: space-between;
}

.center-button-group {
    display: flex;
    justify-content: center;
    margin-top: 12px;
    margin-bottom: 30px;
}

.button-group-auto-l-margin {
    margin-left: auto;
}

.red-must-filled-item {
    color: red;
    margin-left: auto;
}

.customer-creation-component {
    background-color: hsl(213, 46%, 91%) !important;
    border: 2px solid hsl(213, 42%, 38%) !important;
    width: 100% !important;
    font-weight: bold;
}

.customer-component-wrapper {
    background-color: hsl(0, 0%, 95%) !important;
    width: 100% !important;
    border-top: none !important;
}

.component-title-text {
    font-weight: bold !important;
    margin-left: 8px;
}

.el-select-width {
    width: 160px;
}

.el-select-width-small {
    width: 100px;
}
</style>
